DROP TABLE EMP;
DROP TABLE DEPT;
DROP TABLE SALGRADE;

CREATE TABLE persons(
    person_id NUMBER GENERATED BY DEFAULT AS IDENTITY,
    first_name VARCHAR2(50) NOT NULL,
    last_name VARCHAR2(50) NOT NULL,
    PRIMARY KEY(person_id)
);

CREATE TABLE EMP
(EMPNO NUMBER(4) NOT NULL,
ENAME VARCHAR2(10),
JOB VARCHAR2(9),
MGR NUMBER(4),
HIREDATE DATE,
SAL NUMBER(7, 2),
COMM NUMBER(7, 2),
DEPTNO NUMBER(2));
INSERT INTO EMP VALUES
(7369, 'SMITH', 'CLERK', 7902,
TO_DATE('17-MAR-1980', 'DD-MON-YYYY'), 800, NULL, 20);
INSERT INTO EMP VALUES
(7499, 'ALLEN', 'SALESMAN', 7698,
TO_DATE('20-MAR-1981', 'DD-MON-YYYY'), 1600, 300, 30);
INSERT INTO EMP VALUES
(7521, 'WARD', 'SALESMAN', 7698,
TO_DATE('22-MAR-1981', 'DD-MON-YYYY'), 1250, 500, 30);
INSERT INTO EMP VALUES
(7566, 'JONES', 'MANAGER', 7839,
TO_DATE('2-MAR-1981', 'DD-MON-YYYY'), 2975, NULL, 20);
INSERT INTO EMP VALUES
(7654, 'MARTIN', 'SALESMAN', 7698,
TO_DATE('28-MAR-1981', 'DD-MON-YYYY'), 1250, 1400, 30);
INSERT INTO EMP VALUES
(7698, 'BLAKE', 'MANAGER', 7839,
TO_DATE('1-MAR-1981', 'DD-MON-YYYY'), 2850, NULL, 30);
INSERT INTO EMP VALUES
(7782, 'CLARK', 'MANAGER', 7839,
TO_DATE('9-MAR-1981', 'DD-MON-YYYY'), 2450, NULL, 10);
INSERT INTO EMP VALUES
(7788, 'SCOTT', 'ANALYST', 7566,
TO_DATE('09-MAR-1982', 'DD-MON-YYYY'), 3000, NULL, 20);
INSERT INTO EMP VALUES
(7839, 'KING', 'PRESIDENT', NULL,
TO_DATE('17-MAR-1981', 'DD-MON-YYYY'), 5000, NULL, 10);
INSERT INTO EMP VALUES
(7844, 'TURNER', 'SALESMAN', 7698,
TO_DATE('8-MAR-1981', 'DD-MON-YYYY'), 1500, 0, 30);
INSERT INTO EMP VALUES
(7876, 'ADAMS', 'CLERK', 7788,
TO_DATE('12-MAR-1983', 'DD-MON-YYYY'), 1100, NULL, 20);
INSERT INTO EMP VALUES
(7900, 'JAMES', 'CLERK', 7698,
TO_DATE('3-MAR-1981', 'DD-MON-YYYY'), 950, NULL, 30);
INSERT INTO EMP VALUES
(7902, 'FORD', 'ANALYST', 7566,
TO_DATE('3-MAR-1981', 'DD-MON-YYYY'), 3000, NULL, 20);
INSERT INTO EMP VALUES
(7934, 'MILLER', 'CLERK', 7782,
TO_DATE('23-MAR-1982', 'DD-MON-YYYY'), 1300, NULL, 10);

CREATE TABLE DEPT
(DEPTNO NUMBER(2),
DNAME VARCHAR2(14),  
LOC  VARCHAR2(13) );

INSERT INTO DEPT VALUES (10, 'ACCOUNTING', 'NEW YORK');
INSERT INTO DEPT VALUES (20, 'RESEARCH', 'DALLAS');
INSERT INTO DEPT VALUES (30, 'SALES', 'CHICAGO');
INSERT INTO DEPT VALUES (40, 'OPERATIONS', 'BOSTON');
 
CREATE TABLE SALGRADE
(GRADE NUMBER,
LOSAL NUMBER,
HISAL NUMBER);

INSERT INTO SALGRADE VALUES (1, 700, 1200);
INSERT INTO SALGRADE VALUES (2, 1201, 1400);
INSERT INTO SALGRADE VALUES (3, 1401, 2000);
INSERT INTO SALGRADE VALUES (4, 2001, 3000);
INSERT INTO SALGRADE VALUES (5, 3001, 9999);




-------------------- Task 1 ------------------------------

/* 1. Display All data from Salgrade table */

SELECT * FROM Salgrade;


/* 2. Show data ( surname, department,salary) for people whoearn salaries <1000,2000> */

SELECT Ename, Deptno, Sal
FROM Emp
WHERE Sal > 1000 AND Sal < 2000;


/* 3. From table DEPT choose numbers and names of departments.Present data sorted by increasing numbers of departments. */

SELECT Deptno, Dname
FROM Dept
ORDER BY Deptno;


/* 4. Show all different names of jobs. */

SELECT DISTINCT(Job)
FROM Emp;


/* 5. Show all data about people working in department 10 or 20 presenting dat in alphabetic order of their jobs. */

SELECT *
FROM Emp
WHERE Deptno = 10 OR Deptno = 20
ORDER BY Job;


/* 6. Find all names of people from department 20 working as CLERK. */

SELECT Ename
FROM Emp
WHERE Deptno = 20 AND Job = CLERK;


/* 7. Show all names of people who have in their surnames sequence TH or LL included. */

SELECT Ename
FROM Emp
WHERE Ename LIKE '%TH%' OR Ename LIKE '%LL%';


/* 8. Choose names and salaries of people with salaries nit in <1000,2000> and names consisting of 5 characters. */

SELECT Ename, Sal
FROM Emp
WHERE Sal < 1000 OR Sal > 2000;

/* 9. Show names, jobs and salaries of peoplewith names in which L doesnt occur and who earn salaries fifferent from 800, 1600, 3000. */

SELECT Ename, Job, Sal
FROM Emp
WHERE Ename NOT LIKE '%L%' AND Sal NOT IN (800, 1600, 3000);


/* 10. Choose  ( name, job, salary) who are supervised by somebody ( id of the boss is provided by column MGR) */

SELECT e.Ename, e.Job, e.Sal
FROM Emp e
WHERE e.Mgr IS NOT NULL;


/* 11. Choose names and yearly income for all who work as salesman ( do not forget about commision which is paid once a year).The colums showing yearly income shoukd be called ANNSAL */

SELECT Ename, 12 * NVL(Sal, 0) AS ANNSAL
FROM Emp;

/* 12. Show names of all Staff members from dep 10 who are managers. */

SELECT DISTINCT(b.Ename)
FROM Emp e, Emp b
WHERE b.Deptno = 10 AND e.Mgr = b.Empno;


/* 13. Find all people who work since 1983 */

SELECT *
FROM Emp
WHERE Hiredate > '01-JAN-83';

/* 14. Choose names, yearly income and commission  for all who work as salesman and who earn salary smaller then commision. */

SELECT Ename, 12 * NVL(Sal, 0)
FROM Emp
WHERE Job = 'SALESMAN' AND Sal < COMM;


/* 15.Show the title and the data from table Emp in the following way:
Who_what_and_when
Smith has held the position of cleark in dep 10 since 17-Dec-80
 */

SELECT Ename || ' has held the position of ' || Job || ' in dep ' || Deptno || ' since ' || hiredate
FROM Emp;





-------------- Task 2 ---------------------
